## libmmap-allocator 0.4.0%2Bgit20200122.adbfbe1

=== debian/watch ===
version=4

# We really need the latest commit to fit the needs of the target iitii
opts="mode=git,pretty=0.4.0+git%cd.%h" \
  https://github.com/ekg/mmap_allocator.git HEAD

#opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
#https://github.com/ekg/mmap_allocator/releases .*/archive/mmap-allocator-@ANY_VERSION@\.tar\.gz

## libmmap-allocator 0.4.0+git20200122.adbfbe1

=== CMakeLists.txt ===
# Specify the minimum version for CMake

cmake_minimum_required(VERSION 3.1)

# Project's name
project(mmap_allocator)
# We build using c++14
set(CMAKE_CXX_STANDARD 14)

# Use all standard-compliant optimizations
set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS} -O3 -mcx16 -g")
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS} -O3 -mcx16 -g")

#set(CMAKE_BUILD_TYPE Release)
set(CMAKE_BUILD_TYPE Debug)

# set up our target executable and specify its dependencies and includes
add_library(mmap_allocator_objs OBJECT
  ${CMAKE_SOURCE_DIR}/mmap_file_pool.cpp)

set(mmap_allocator_INCLUDES
  ${CMAKE_SOURCE_DIR})

set(mmap_allocator_HEADERS
  ${CMAKE_SOURCE_DIR}/mmap_access_mode.h
  ${CMAKE_SOURCE_DIR}/mmap_allocator.h
  ${CMAKE_SOURCE_DIR}/mmap_exception.h
  ${CMAKE_SOURCE_DIR}/mmap_file_pool.h
  ${CMAKE_SOURCE_DIR}/mmappable_vector.h)

target_include_directories(mmap_allocator_objs PUBLIC ${mmap_allocator_INCLUDES})
set_target_properties(mmap_allocator_objs PROPERTIES POSITION_INDEPENDENT_CODE TRUE)

add_library(libmmap_allocator_static STATIC $<TARGET_OBJECTS:mmap_allocator_objs>)
set_target_properties(libmmap_allocator_static PROPERTIES OUTPUT_NAME "mmap_allocator")
set_target_properties(libmmap_allocator_static PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
add_library(libmmap_allocator_shared SHARED $<TARGET_OBJECTS:mmap_allocator_objs>)
set_target_properties(libmmap_allocator_shared PROPERTIES OUTPUT_NAME "mmap_allocator")
set_target_properties(libmmap_allocator_shared PROPERTIES POSITION_INDEPENDENT_CODE TRUE)

set_target_properties(libmmap_allocator_static PROPERTIES PUBLIC_HEADER "${mmap_allocator_HEADERS}")
set_target_properties(libmmap_allocator_shared PROPERTIES PUBLIC_HEADER "${mmap_allocator_HEADERS}")

add_executable(test_mmap_allocator
  $<TARGET_OBJECTS:mmap_allocator_objs>
  ${CMAKE_SOURCE_DIR}/test_allocator.cpp)
#set_target_properties(mmap_allocator PROPERTIES OUTPUT_NAME "mmap_allocator")

install(TARGETS test_mmap_allocator DESTINATION bin)
install(TARGETS libmmap_allocator_static ARCHIVE DESTINATION lib LIBRARY DESTINATION lib PUBLIC_HEADER DESTINATION include/mmap_allocator)
install(TARGETS libmmap_allocator_shared ARCHIVE DESTINATION lib LIBRARY DESTINATION lib PUBLIC_HEADER DESTINATION include/mmap_allocator)

=== Makefile ===
CPPFLAGS=-g -Wall -fPIC
CFLAGS=-g -Wall -fPIC

# Enable to test with GCC 3.4
# CXX=g++34

PREFIX=/usr

SOURCES=mmap_file_pool.cpp mmap_file_pool.h mmap_allocator.h mmap_access_mode.h mmappable_vector.h mmap_exception.h

HEADERS=mmap_access_mode.h mmap_allocator.h mmap_file_pool.h mmap_exception.h
LIBRARIES=libmmap_allocator.so libmmap_allocator.a

SRC_INSTALL_TARGET_DIR=/home/johannes/re3

all: test_allocator mmap_file_pool.o $(LIBRARIES)

debug: CPPFLAGS+=-DMMAP_ALLOCATOR_DEBUG=1
debug: CFLAGS+=-DMMAP_ALLOCATOR_DEBUG=1
debug: clean all

libmmap_allocator.so: mmap_file_pool.o
	g++ -shared -o libmmap_allocator.so mmap_file_pool.o

libmmap_allocator.a: mmap_file_pool.o
	ar r libmmap_allocator.a mmap_file_pool.o

install_sources: $(SOURCES)
	cp $(SOURCES) $(SRC_INSTALL_TARGET_DIR)

install: all
	install -m 644 $(HEADERS) $(PREFIX)/include
	install -m 755 $(LIBRARIES) $(PREFIX)/lib
	
test: all
	@echo "Running mmap allocator regression test suite."
	bash -c 'export LD_LIBRARY_PATH=. ; ./test_allocator'

debugtest: debug
	@echo "Running mmap allocator regression test suite with verbose enabled."
	bash -c 'export LD_LIBRARY_PATH=. ; ./test_allocator'

test_allocator: mmap_allocator.h mmap_file_pool.o test_allocator.o $(LIBRARIES)
	g++ test_allocator.o -L. -lmmap_allocator -o test_allocator

test_mmap_fixed: test_mmap_fixed.c
	gcc $(CFLAGS) test_mmap_fixed.c -o test_mmap_fixed

clean:
	rm -f test_allocator test_mmap_fixed testfile testfile2 *.o $(LIBRARIES)

mmap_file_pool.o: mmap_file_pool.cpp mmap_file_pool.h mmap_allocator.h mmap_access_mode.h mmappable_vector.h mmap_exception.h

test_allocator.o: test_allocator.cpp mmap_file_pool.h mmap_allocator.h mmap_access_mode.h mmappable_vector.h mmap_exception.h

=== debian/changelog ===
libmmap-allocator (0.4.0+git20200122.adbfbe1-1) unstable; urgency=medium

  * For iitii package the latest commit is needed

 -- Andreas Tille <tille@debian.org>  Thu, 11 Jun 2020 22:17:30 +0200

libmmap-allocator (0.4.0-1) unstable; urgency=medium

  * Initial release (Closes: #962315)

 -- Andreas Tille <tille@debian.org>  Sat, 06 Jun 2020 07:31:08 +0200

=== debian/control ===
Source: libmmap-allocator
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: libdevel
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-exec
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/libmmap-allocator
Vcs-Git: https://salsa.debian.org/med-team/libmmap-allocator.git
Homepage: https://github.com/ekg/mmap_allocator/

Package: libmmap-allocator-dev
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: STL allocator that mmaps files
 When reading large files (>100MB) into memory, read() calls are usually
 not very space and time efficient, since the whole data is copiied at
 least once. Furthermore, when using STL containers (like a vector for
 example), data is copiied another time unless the location of the vector
 content as parameter to read() will be specified.
 .
 It would be nice to tell the vector a filename and have the vector mmap
 the file directly. This not only avoids the read() copiing (and the STL
 vector copiing) but also allows different processes that read the same
 file to see the same physical memory. Fortunately STL foresees an
 interface to do exactly this.
 .
 Libmmap-allocator helps to handle big files that contain unstructured
 data (like doubles or even text files), mmap_allocator is worth a try.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

%:
	dh $@

override_dh_auto_build:
	$(MAKE) libmmap_allocator.so libmmap_allocator.a

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make test
endif

override_dh_auto_install:
	echo "Do nothing to install"
#	mkdir -p debian/`dh_listpackages`/usr/include
#	dh_auto_install -- TARGET_DIR=debian/`dh_listpackages`/usr/include
